"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var literal_1 = require("./literal");
function getDataTypeByNodeName(node) {
    var NodeName = node ? node.NodeName : "";
    switch (NodeName) {
        case "IntegerLiteral":
            return "int";
        case "FloatLiteral":
            return "float";
        case "BooleanLiteral":
            return "boolean";
        case "ArrayLiteral":
            return "array";
        case "HashLiteral":
            return "hash";
        // handle NewExpression
        default:
            return "any";
    }
}
exports.getDataTypeByNodeName = getDataTypeByNodeName;
var ZeroFloat = new literal_1.FloatLiteral({ Literal: "0.0", Type: "FLOAT" }, 0.0);
var ZeroInt = new literal_1.IntegerLiteral({ Literal: "0", Type: "INT" }, 0);
var EmptyString = new literal_1.StringLiteral({ Literal: "", Type: "STRING" }, "");
var FALSE = new literal_1.BooleanLiteral({ Literal: "false", Type: "BOOLEAN" }, false);
function getDefaultValueNodeForDataType(dataType) {
    switch (dataType) {
        case "int":
            return ZeroInt;
        case "float":
            return ZeroFloat;
        case "string":
            return EmptyString;
        case "boolean":
            return FALSE;
        default:
            return FALSE;
    }
}
exports.getDefaultValueNodeForDataType = getDefaultValueNodeForDataType;
