"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var object = require("../../object/object");
var object_1 = require("../../object/object");
var util_1 = require("../../util");
var node_objects_1 = require("../../repl/node-objects");
var file_1 = require("./file");
var obj_util_1 = require("../../object/obj-util");
var obj_util_2 = require("../../object/obj-util");
var error_1 = require("../../object/error");
var builtin_util_1 = require("../builtin-util");
var human_1 = require("./human");
var readLn = new object.Builtin("readLn", [], function (context, scope, jsScope, promptMessage) {
    return util_1.platformSpecificCall(context, scope, function () { return util_1.readStdInSync(node_objects_1.nodeObjects.Buffer, node_objects_1.nodeObjects.fs, node_objects_1.nodeObjects.process); }, function () {
        if (!promptMessage || typeof promptMessage != "string") {
            return error_1.newError("In web mode, readLn requires a string argument for the message in the popup.");
        }
        return new object_1.StringObject(util_1.readLineFromDocument(promptMessage));
    }, function () { return util_1.workerNativeCall(context, "readLine", [promptMessage], false); }, [promptMessage]);
}, "io");
var GetArgs = new object.Builtin("getArgs", [], function (context, scope, jsScope) {
    var args = [];
    for (var _i = 3; _i < arguments.length; _i++) {
        args[_i - 3] = arguments[_i];
    }
    return util_1.platformSpecificCall(context, scope, function () { return node_objects_1.nodeObjects.process.argv.slice(3); }, function () { return util_1.getWindow().location.split("/"); }, function () { return util_1.workerNativeCall(context, "getArgs", args, false); }, args);
}, "io");
var SerialBus = builtin_util_1.makeBuiltinInterface([
    obj_util_1.makeEventSource("SerialBus", "read"),
    obj_util_2.makeEventSink("SerialBus", "write"),
]);
var HostEvents = builtin_util_1.makeBuiltinInterface([
    obj_util_1.makeEventSource("HostEvents", "addListener"),
    obj_util_2.makeEventSink("HostEvents", "dispatch"),
]);
var FileObj = builtin_util_1.makeBuiltinClass("File", [
    ["resource", new object_1.StringObject("")],
    ["File", file_1.fileConstructor],
    ["open", file_1.fileOpen],
    // ["hasNextLine", fileHasNextLine],
    // ["readLine", fileReadLine],
    ["writeLine", file_1.fileWriteLine],
    ["readAll", file_1.fileReadAll]
]);
exports.io = builtin_util_1.makeBuiltinInterface([
    ["args", GetArgs],
    ["HostEvents", HostEvents],
    ["SerialBus", SerialBus],
    ["File", FileObj],
    ["readLine", readLn],
    ["keyDown", human_1.onKeyDown],
    ["keyUp", human_1.onKeyUp]
]);
