"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var obj_util_1 = require("../../object/obj-util");
var object = require("../../object/object");
var object_1 = require("../../object/object");
var builtin_util_1 = require("../builtin-util");
var stringify = new object.Builtin("stringify", [[object.HASH_OBJ, object.ARRAY_OBJ]], function (context, scope, jsScope) {
    if (context === void 0) { context = null; }
    if (scope === void 0) { scope = null; }
    var args = [];
    for (var _i = 3; _i < arguments.length; _i++) {
        args[_i - 3] = arguments[_i];
    }
    var data;
    if (args[0].Type() == object.HASH_OBJ) {
        data = obj_util_1.objectToNativeObject(args[0]);
    }
    else {
        data = obj_util_1.arrayToNativeList(args[0]);
    }
    return new object_1.StringObject(JSON.stringify(data));
}, null, null, null, true);
var parse = new object.Builtin("parse", [object.STRING_OBJ], function (context, scope, jsScope) {
    if (context === void 0) { context = null; }
    if (scope === void 0) { scope = null; }
    var args = [];
    for (var _i = 3; _i < arguments.length; _i++) {
        args[_i - 3] = arguments[_i];
    }
    var obj = JSON.parse(args[0].Value);
    return typeof obj.length == "number" ? obj_util_1.nativeListToArray(obj) : obj_util_1.nativeObjToMap(obj);
}, null, null, null, true);
exports.ECS_JSON = builtin_util_1.makeBuiltinInterface([["parse", parse], ["stringify", stringify]]);
