"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var object = require("../object/object");
var util_1 = require("../util");
var builtin_util_1 = require("./builtin-util");
exports.getTerminalSize = function (scope) {
    if (scope === void 0) { scope = null; }
    var stdout = process ? process.stdout : null;
    return [
        stdout != null ? stdout.columns : scope ? scope.width : -2,
        stdout != null ? stdout.rows : scope ? scope.height : -2,
    ];
};
exports.getDOMTerminalSize = function () {
    var output = util_1.getDocument().querySelector("#ecs-output");
    var x = 1, y = 1;
    if (output) {
        x = Math.floor(output.clientWidth / 12);
        y = Math.floor(output.clientHeight / 26) || 28;
    }
    return [x, y];
};
var clear = new object.Builtin("clear", [], function (context, scope) {
    util_1.platformSpecificCall(context, scope, function () { console.clear(); }, function () { /* web */ util_1.getDocument().querySelector("#ecs-output").innerHTML = ""; }, function () { util_1.workerNativeCall(context, "clear", []); }, []);
    return object.NULL;
}, "terminal"), getDimensions = new object.Builtin("getDimensions", [], function (context, scope) {
    return util_1.platformSpecificCall(context, scope, function () { return exports.getTerminalSize(scope); }, function () { return exports.getDOMTerminalSize(); }, function () { return [0, 0]; }, []);
}, "terminal"), hasColorSupport = new object.Builtin("hasColorSupport", [], function (context, scope) {
    return util_1.platformSpecificCall(context, scope, function () { return true; }, function () { return false; }, function () { return true; }, []);
}, "terminal"), has3dSupport = new object.Builtin("has3dSupport", [], function (context, scope) {
    return util_1.platformSpecificCall(context, scope, function () { return false; }, function () { return true; }, function () { return true; }, []);
}, "terminal"), beep = new object.Builtin("beep", [], function (context, scope) {
    util_1.platformSpecificCall(context, scope, function () { return console.log('\u0007'); }, function () { /* web */ util_1.getDocument().querySelector("#ecs-beep").play(); }, function () { util_1.workerNativeCall(context, "beep", []); }, []);
    return object.NULL;
}, "terminal");
exports.terminal = builtin_util_1.makeBuiltinInterface([
    ["clear", clear],
    ["getDimensions", getDimensions],
    ["hasColorSupport", hasColorSupport],
    ["has3dSupport", has3dSupport],
    ["beep", beep]
]);
