import { REPLPlugins } from './repl';
import { Environment } from './object/environment';
import { Parser, ParseResult } from './parser';
import { Lexer } from './lexer';
import { Transpiler } from './transpiler';
import { ECSRuntime } from './runtime';
export declare class ECS {
    config: any;
    env: Environment;
    window: any;
    constructor(config: any);
    repl(args?: string[], makeCLIRepl?: (l: Lexer, p: Parser, Environment: any, plugins?: REPLPlugins) => any, replPlugins?: REPLPlugins): void;
    webRepl(): void;
    getEnv(): Environment;
    static makeRuntimeEnvironment(): ECSRuntime;
    static makeEnvironment(): Environment;
    static parse(sourceCode: string): ParseResult;
    static transpile(augmentedAST: ParseResult, customCompiler?: Transpiler): any;
}
