import { Environment } from "./environment";
import { ApplyFunctionFunction } from "./function";
import { Program } from "../ast";
import { AnyObject } from "../util";
export interface EvaluatorContext {
    applyFunction: ApplyFunctionFunction;
    setProgram: (program: Program) => EvaluatorContext;
    setEnv: (env: Environment) => EvaluatorContext;
    getVar: (identName: string) => any;
    setVar: (identName: string, value: any) => any;
    call: (identName: string, args: any[]) => any;
    callMethod(className: string, methodName: string, args: any[], instance?: AnyObject): any;
    callBuiltin(identName: string, args: any[]): any;
}
