import { FunctionObject, EObject } from "./object";
import { ECSRuntime } from "../runtime";
import { EventContext, WorkerContext } from "../runtime/events";
export declare class Environment {
    private store;
    outer?: Environment;
    context: WorkerContext;
    events: {
        [namespace: string]: {
            [eventName: string]: FunctionObject[];
        };
    };
    constructor(outer?: Environment, context?: WorkerContext);
    get(name: string): EObject;
    set(name: string, value: any): EObject;
    getContext: () => WorkerContext;
    setContext(name: string, value: any): void;
    /***
     * addEventHandler is called from builtin functions to register external observables
     */
    addEventHandler(system: string, eventName: string, callback: FunctionObject): void;
    /***
     * onEvent is called when the web-worker gets an `event` message from outside
     * This is the hot path 🔥🔥🔥
     */
    onEvent(system: string, eventName: string, data: any[], interpreter: ECSRuntime, env: Environment, synchronousContext?: EventContext): void;
    private hasEvents;
    private initEvents;
}
export declare function NewEnclosedEnvironment(outer: Environment): Environment;
export declare function makeSynchronousEventContext(path: [string, number, number], data?: {
    [_: string]: any;
}): {
    data: {
        [_: string]: any;
    };
    postMessage: (command: any, data: any) => void;
};
