import { EObject, FunctionObject, Hash, ArrayObject, LambdaFunction } from './object';
import { AnyObject } from '../util';
import { Optimizer } from '../runtime/optimizer';
import { Environment } from './environment';
export declare const instanceMethodError = "non-static, instance methods must be called on an instance";
export declare function copyListElements(list: ArrayObject): any[];
export declare let copyList: (list: ArrayObject) => ArrayObject;
export declare function copyHashMap(data: Hash): Hash;
export declare function copyObject(valueNode: any, objectContext?: Hash): EObject;
export declare function copyFunction(fn: LambdaFunction, objectContext: Hash): LambdaFunction;
export declare function assignHashPairs(from: Hash, to: Hash): Hash;
export declare let nativeValueToECSValue: (element: any) => EObject;
export declare let nativeListToArray: (obj: any[]) => ArrayObject;
export declare function listOfObjectsToNativeList(obj: EObject[], opt: Optimizer): any[];
export declare function nativeListToListOfObjects(obj: any[]): EObject[];
export declare function numberArrayToFloatArray(numbers: number[]): ArrayObject;
export declare let nativeObjToMap: (obj?: {
    [key: string]: any;
}) => Hash;
export declare const assignNativeProperties: (to: Hash, from: {
    [_: string]: any;
}) => void;
export declare const assignNativePropertiesToJSObj: (to: AnyObject, from: {
    [_: string]: any;
}) => void;
export declare const ecsObjectToNativeObject: (obj: EObject, opt?: Optimizer, env?: Environment) => any;
export declare let objectToNativeObject: (map: Hash) => {
    [key: string]: any;
};
export declare let arrayToNativeList: (arr: ArrayObject, opt?: Optimizer, env?: Environment) => any[];
export declare let nativePairValue: (hash: Hash, key: string) => string | number | boolean;
export declare let makeEventSource: (prefix: string, event: string) => [string, FunctionObject];
export declare let makeEventSink: (prefix: string, event: string) => [string, FunctionObject];
