"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var repl_util_1 = require("./repl-util");
var evaluator = require("../evaluator");
function makeWebRepl(l, p, env) {
    console.log("start web REPL");
    var webEvaluate = function (text) {
        if (text[text.length - 1] != ";") {
            text = text + ";";
        }
        l.setText(text);
        p.parse();
        var program = p.parseProgram(), evaluated;
        //console.log(JSON.stringify(program));
        if (p.Errors().length != 0) {
            repl_util_1.printParserErrors(p.Errors());
            return;
        }
        evaluated = evaluator.Eval(program, env);
        if (evaluated != null) {
            if (evaluated.Inspect) {
                console.log(evaluated.Inspect());
                return evaluated.Inspect();
            }
        }
    };
    var win = 'window';
    var wind = eval(win) != undefined ? eval(win) : undefined;
    var document = wind ? wind.document : null;
    document.addEventListener("DOMContentLoaded", function () {
        var evaluateText = function () {
            document.querySelector("#ecs-output").innerHTML += webEvaluate(document.querySelector("#ecs-input").value.trim()) + "<br/>\n";
            document.querySelector("#ecs-input").value = '';
        };
        document.querySelector("#ecs-button").addEventListener("click", evaluateText, true);
        document.querySelector("#ecs-input").addEventListener("keydown", function (e) {
            if (e.keyCode == 13) {
                evaluateText();
            }
        }, true);
    });
}
exports.makeWebRepl = makeWebRepl;
