"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var environment = require("../object/environment");
var lexer = require("../lexer");
var parser = require("../parser");
var browser_1 = require("./browser");
var env;
function startRepl(mode, args, makeCLIRepl, replPlugins) {
    var l = new lexer.Lexer(), p = new parser.Parser(l), env = new environment.Environment();
    if (!mode || mode == "cli") {
        // break this out into its own entry point to remove the Buffer dependency from browserify bundles
        makeCLIRepl(l, p, env, replPlugins)(args);
    }
    else if (mode == "convolvr") {
        // implement
    }
    else {
        browser_1.makeWebRepl(l, p, env);
    }
    return env;
}
exports.startRepl = startRepl;
