import { Environment } from "../object/environment";
import { ECSRuntime } from ".";
import { AnyObject } from "../util";
export interface EventContext {
    postMessage: (command: string, data: {
        [_: string]: any;
    }) => void;
    env?: Environment;
    data?: AnyObject;
}
export interface WorkerContext extends EventContext {
}
export declare const SynchronousEventContext: WorkerContext;
export interface HostEvents {
}
export declare class ECSHostEvents {
    private synchronousContext;
    interpreter: ECSRuntime;
    eventHandlers: {};
    constructor(synchronousContext: WorkerContext);
    setInterpreter(interpreter: ECSRuntime): void;
    /**
     * When running ECS outside of a web-worker, posted messages can be handled via this function
     */
    handleAddEventHandler(commandName: string, handler: (event: any) => void): void;
    dispatchHostEvent(env: Environment, eventName: string, data: any[]): void;
    addHostEventHandler(env: Environment, eventName: string, handler: (data: any) => void): void;
}
