import * as object from '../object/object';
import { Environment } from '../object/environment';
import * as lexer from '../lexer';
import * as parser from '../parser';
import { Program } from '../ast';
import { ECSHostEvents, HostEvents } from './events';
import { EvalFunction, EvalProgramFunction, EvalBodyAndApplyFunctionFn } from './eval';
export declare type Interpreter = {
    tokenizer: lexer.Lexer;
    parser: parser.Parser;
    eval: EvalFunction;
    makeEnvironment: (outer: Environment) => Environment;
    parseAndEvaluate: (text: string, env: Environment, onErrors: Function, joinNewLines?: boolean) => object.inspectTypes | null;
    evaluateProgram: (program: Program, env: Environment, onErrors: Function) => object.inspectTypes | null;
    parse: (code: string, onError: Function) => Program;
};
export declare class ECSRuntime implements Interpreter {
    applyFunction: EvalBodyAndApplyFunctionFn;
    events: ECSHostEvents;
    constructor(_tokenizer: lexer.Lexer, _parser: parser.Parser, evalFunction: EvalFunction, evalProgramFunction: EvalProgramFunction, applyFunction: EvalBodyAndApplyFunctionFn);
    tokenizer: lexer.Lexer;
    parser: parser.Parser;
    eval: EvalFunction;
    evalProgram: EvalProgramFunction;
    makeEnvironment: (outer: any) => Environment;
    parseAndEvaluate: (text: string, env: Environment, onErrors: Function, joinNewLines?: boolean) => string | number | boolean;
    parse: (code: string, onError: Function) => Program;
    evaluateProgram: (program: Program, env: any, onErrors: Function) => string | number | boolean;
}
export declare let makeRuntimeEnvironment: (evalFunction: EvalFunction, evalProgram?: EvalProgramFunction, evalBodyAndApplyFunctionFn?: EvalBodyAndApplyFunctionFn, hostEvents?: HostEvents) => ECSRuntime;
