import { ApplyFunctionFunction } from "../object/function";
import { Environment } from "../object/environment";
import { EvaluatorContext } from "../object/context";
import { Program } from "../ast";
import { AnyObject } from "../util";
import { EvalFunction } from "./eval";
export declare class JSECSEvaluatorContext implements EvaluatorContext {
    program: Program;
    env: Environment;
    applyFunction: ApplyFunctionFunction;
    evalFn: EvalFunction;
    constructor(applyFunction: ApplyFunctionFunction, evalFn: EvalFunction);
    setProgram(program: Program): JSECSEvaluatorContext;
    setEnv(env: Environment): JSECSEvaluatorContext;
    getVar(identName: string): any;
    getBuiltin(identName: string): any;
    getBuiltinObject(identName: string, fieldName: string): any;
    setVar(identName: string, value: any): any;
    callMethod(className: string, methodName: string, args: any[], instance?: AnyObject): any;
    call(identName: string, args: any[]): any;
    callBuiltin(identName: string, args: any[]): any;
    private handleCallBuiltinConstructor;
    private handleCallAndConvertResultToJS;
}
