import { Node } from "../ast";
import { ParseTreeAnalysis } from "../parser";
/**
 * Analyzer creates a ParseTreeAnalysis from
 * a pre-parsed Program AST node, much like the parser would.
 *
 * The use-case is that a program may already be parsed either from:
 * - compiling hot functions,
 * - or importing a Program from an AST editor.
 */
export declare class Analyzer {
    analyzeParseTree(program: Node): ParseTreeAnalysis;
    private analyzeNode;
    private isLoop;
    private analyzeCallExpression;
    private analyzeFunction;
    private analyzeBlockStatement;
    private analyzeLetStatement;
    private analyzeExternalVars;
    private initAnalysis;
}
