import { Transpiler } from ".";
import { ForStatement, IfStatement, WhileStatement, SleepStatement, ExpressionStatement } from "../ast/statement";
import { CallExpression, IndexExpression, NewExpression } from "../ast/expression";
import { LetStatement, ClassStatement } from "../ast/statement";
import { ArrayLiteral, HashLiteral, FunctionLiteral } from "../ast/literal";
/**
 * ECS to Javascript Un-parse-r
 */
export declare class JSTranspiler extends Transpiler {
    builtinFunctionPolyfill: {
        "time": string;
    };
    isomorphicBuiltins: {
        "Math": boolean;
        "RegExp": boolean;
    };
    typeToTypeMapping: {};
    literalToTypeMapping: {};
    protected onRunWithoutPlugins: () => void;
    protected methodCallPolyfill: {
        "terminal": {
            clear: any;
            getDimensions: any;
            beep: (node: CallExpression) => CallExpression;
        };
    };
    protected callExpressionPolyfill: {
        "push": (node: CallExpression) => CallExpression;
        "pop": (node: CallExpression) => CallExpression;
        "splice": (node: CallExpression) => CallExpression;
        "concat": (node: CallExpression) => CallExpression;
        "join": (node: CallExpression) => CallExpression;
        "split": (node: CallExpression) => CallExpression;
        "len": (node: CallExpression) => IndexExpression;
    };
    mutantFunctions: string[];
    endOfStatementDelimiter: string;
    protected delta: {
        NewExpression: (node: NewExpression) => any;
        ArrayLiteral: (node: ArrayLiteral) => string;
        HashLiteral: (node: HashLiteral) => string;
        FunctionLiteral: (node: FunctionLiteral) => string;
        PureFunctionLiteral: (node: FunctionLiteral) => string;
        ExpressionStatement: (node: ExpressionStatement) => string;
        LetStatement: (node: LetStatement) => string;
        ClassStatement: (node: ClassStatement) => string;
        IfStatement: (node: IfStatement) => string;
        ForStatement: (node: ForStatement) => string;
        WhileStatement: (node: WhileStatement) => string;
        SleepStatement: (node: SleepStatement) => string;
    };
}
export declare function JSTerminalClear(node: CallExpression): CallExpression;
export declare function JSGetTerminalSize(): ArrayLiteral;
