import { Node } from "../ast";
import { Transpiler } from ".";
export declare const UNPARSER_TYPES: string[];
export interface UnParser {
    unParse: (node: Node) => string;
}
export declare abstract class UnParserPlugin {
    setTranspiler(unparser: Transpiler): void;
    affectedIdentifiers: {
        [identName: string]: boolean;
    };
    resolvedIdentifiers: {
        [identName: string]: boolean;
    };
    nodeTransforms: {
        [NodeName: string]: (node: Node, topScope?: boolean) => (Node | string)[];
    };
    protected transpiler: Transpiler;
    constructor();
}
