"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fg = Array.apply(null, new Array(256)).map(function (_, idx) { return '\x1b[38;5;' + idx + 'm'; }), rgb = fg.slice(16, 232);
function getRGB(r, g, b) { return rgb[36 * (r % 6) + 6 * (g % 6) + (b % 6)]; }
function render8BitColor(vec, str) {
    return getRGB(Math.floor(Math.abs(vec[0] * 4)), Math.floor(Math.abs(vec[1] * 4)), Math.floor(Math.abs(vec[2] * 4))) + str;
}
// TODO: implement blit to canvas to avoid using this abomination:
function renderHTMLColor(val, str) {
    return '<span style="color: rgb(' + Math.floor(val[0] * 255) + ',' + Math.floor(val[1] * 255) + ',' + Math.floor(val[2] * 255) + ')">' + str + '</span>';
}
var ColorRendererFactory = /** @class */ (function () {
    function ColorRendererFactory() {
    }
    ColorRendererFactory.get = function () {
        if (typeof Window != 'undefined') {
            return renderHTMLColor;
        }
        return render8BitColor;
    };
    return ColorRendererFactory;
}());
exports.ColorRendererFactory = ColorRendererFactory;
exports.systemColorRenderer = ColorRendererFactory.get();
