"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var error_1 = require("./object/error");
var object_1 = require("./object/object");
exports.scaleString = function (input, scale) {
    var l = input.length, i = 0, o = "";
    while (i < l) {
        o += input[i].repeat(scale[0]);
        i += 1;
    }
    return o;
};
function getWindow() {
    var win = 'window';
    return (eval(win) != undefined ? eval(win) : undefined);
}
exports.getWindow = getWindow;
function getDocument() {
    var win = getWindow();
    return !!win ? win.document : null;
}
exports.getDocument = getDocument;
function readLineFromDocument(prompt) {
    var win = getWindow();
    return win ? win.prompt(prompt) : "Error: no document to prompt user with";
}
exports.readLineFromDocument = readLineFromDocument;
function printToDocument(value) {
    var doc = getDocument(), out = doc.querySelector("#ecs-output"), item = doc.createElement("div");
    item.setAttribute("class", "ecs-output-item");
    item.innerHTML = value;
    out.appendChild(item);
}
exports.printToDocument = printToDocument;
;
function platformSpecificCallNoSpread(context, scope, nodeImpl, webImpl, webWorkerImpl, args) {
    if (typeof Window == 'undefined' && typeof self === 'undefined') {
        return nodeImpl(context, scope, args);
    }
    else if (self.document != undefined) {
        return webImpl(context, scope, args);
    }
    else {
        return webWorkerImpl(context, scope, args);
    }
}
exports.platformSpecificCallNoSpread = platformSpecificCallNoSpread;
;
function platformSpecificCall(context, scope, nodeImpl, webImpl, webWorkerImpl, args) {
    if (typeof Window == 'undefined' && typeof self === 'undefined') {
        if (args) {
            return nodeImpl.apply(void 0, __spreadArrays([context, scope], args));
        }
        else {
            return nodeImpl(context, scope, []);
        }
    }
    else if (self.document != undefined) {
        if (args) {
            return webImpl.apply(void 0, __spreadArrays([context, scope], args));
        }
        else {
            return webImpl(context, scope, []);
        }
    }
    else {
        if (args) {
            return webWorkerImpl.apply(void 0, __spreadArrays([context, scope], args));
        }
        else {
            return webWorkerImpl(context, scope, []);
        }
    }
}
exports.platformSpecificCall = platformSpecificCall;
;
function workerNativeCall(context, callName, args, native) {
    if (native === void 0) { native = true; }
    context.postMessage("native-call", {
        method: callName,
        args: args.map(function (arg) { return native ? arg : arg.Inspect(); })
    });
}
exports.workerNativeCall = workerNativeCall;
exports.println = function (context, scope, jsScope, args) {
    platformSpecificCall(context, scope, function () {
        var out = "";
        for (var l = args.length, a = 0; a < l; a++) {
            var arg = args[a];
            if (arg && (!arg.Type || arg.Type() != object_1.NULL_OBJ)) {
                out += (arg.Inspect ? arg.Inspect() : arg);
                if (a < l - 1) {
                    out += ",";
                }
            }
        }
        console.log(out);
    }, function () {
        args.forEach(function (arg) {
            printToDocument("" + (arg.Inspect ? arg.Inspect() : arg));
        });
    }, function () {
        workerNativeCall(context, "print", args, false);
    }, args);
};
exports.printNativeString = function (context, scope, str) {
    if (typeof Window == 'undefined') {
        console.log(str);
    }
    else if (context && self.postMessage) {
        workerNativeCall(context, "print", [str]);
    }
    else {
        printToDocument(str);
    }
};
function readStdInSync(Buffer, fs, process) {
    var BUFSIZE = 256;
    var buf = new Buffer(BUFSIZE), bytesRead;
    while (true) { // Loop as long as stdin input is available.
        bytesRead = 0;
        try {
            bytesRead = fs.readSync(process.stdin.fd, buf, 0, BUFSIZE);
        }
        catch (e) {
            if (e.code === 'EAGAIN') { // 'resource temporarily unavailable'
                // Happens on OS X 10.8.3 (not Windows 7!), if there's no
                // stdin input - typically when invoking a script without any
                // input (for interactive stdin input).
                // If you were to just continue, you'd create a tight loop.
                throw 'ERROR: interactive stdin input not supported.';
            }
            else if (e.code === 'EOF') {
                // Happens on Windows 7, but not OS X 10.8.3:
                // simply signals the end of *piped* stdin input.
                break;
            }
            throw e; // unexpected exception
        }
        if (bytesRead === 0) {
            // No more stdin input available.
            // OS X 10.8.3: regardless of input method, this is how the end 
            //   of input is signaled.
            // Windows 7: this is how the end of input is signaled for
            //   *interactive* stdin input.
            break;
        }
        // Process the chunk read.
        return buf.toString("utf8", 0, bytesRead);
    }
}
exports.readStdInSync = readStdInSync;
//TODO: make into platform specific call
exports.getSourceFile = function (path, readWholeFile, fs) {
    var file = "", resource = new Promise(function (resolve, reject) { if (false) {
        reject();
    } return resolve(); });
    // needs to be platform specific-call
    if (path.indexOf("://") > -1) {
    }
    else {
        return readWholeFile(path, fs);
    }
    return resource;
};
//TODO: make into platform specific call
exports.evaluateSourceFile = function (env, embeddedInterpreter, path, readWholeFile, fs) {
    return exports.getSourceFile(path, readWholeFile, fs).then(function (data) {
        embeddedInterpreter.parseAndEvaluate(data, env, function (errors) {
            console.log(error_1.newError("source failed: " + path));
            console.log("source errors:", errors);
        });
    }).catch(function (err) {
        exports.printNativeString(null, null, err + "");
    });
};
var getSourceFileNode = function () {
};
